SHELL := /bin/bash

CC = ${CLANGCC}

CFLAGS = -O0 -static

HARDBLARE_FLAGS = -mllvm -hardblare-annot -mllvm -hardblare-instr /opt/poky/2.3.2/sysroots/cortexa9hf-neon-poky-linux-musleabi/usr/lib/hardblare/libc.a

DEBUG_FLAGS = -mllvm -debug

APP = read-annnotsPropa-write

all: env $(APP).elf $(APP).s $(APP).annot $(APP).bbt $(APP).text $(APP)-whitout-annots.elf $(APP)-complete-annots.elf $(APP)-complete-annots.elf $(APP)-modified-annots.elf $(APP)-modified-annots.text $(APP)-modified-annots.bbt $(APP)-modified-annots.annot


env:
	source /opt/poky/2.3.2/environment-setup-cortexa9hf-neon-poky-linux-musleabi
	echo ${CLANGCC}


$(APP).elf: $(APP).c
	$(CC) $(CFLAGS) $(HARDBLARE_FLAGS) $(DEBUG_FLAGS) $(APP).c -o $(APP).elf 2> $(APP).llvmdebug

$(APP).s: $(APP).elf
	$(CC) $(CFLAGS) $(HARDBLARE_FLAGS) -S $(APP).c -o $(APP).s

$(APP).annot: $(APP).elf
	$(OBJDUMP) -s --section=.HB.annot $(APP).elf > $(APP).annot

$(APP).bbt: $(APP).elf
	$(OBJDUMP) -s --section=.HB.bbt $(APP).elf > $(APP).bbt

$(APP).text: $(APP).elf
	$(OBJDUMP) -d $(APP).elf > $(APP).text

$(APP)-whitout-annots.elf: $(APP).c
	$(CC) $(CFLAGS) $(APP).c -o $(APP)-whitout-annots.elf

$(APP)-complete-annots.elf : CFLAGS += /opt/poky/2.3.2/sysroots/cortexa9hf-neon-poky-linux-musleabi/usr/lib/hardblare/libc.a

$(APP)-complete-annots.elf : $(APP).c
	$(CC) $(CFLAGS) $(HARDBLARE_FLAGS) $(APP).c -o $(APP)-complete-annots.elf

$(APP)-modified-annots.elf: $(APP)-modified-annots.s
	$(CC) $(CFLAGS) $(HARDBLARE_FLAGS) $(APP)-modified-annots.s -o $(APP)-modified-annots.elf

$(APP)-modified-annots.text: $(APP)-modified-annots.elf
	$(OBJDUMP) -d $(APP)-modified-annots.elf > $(APP)-modified-annots.text

$(APP)-modified-annots.bbt: $(APP)-modified-annots.elf
	$(OBJDUMP) -s --section=.HB.bbt $(APP)-modified-annots.elf > $(APP)-modified-annots.bbt

$(APP)-modified-annots.annot: $(APP)-modified-annots.elf
	$(OBJDUMP) -s --section=.HB.annot $(APP)-modified-annots.elf > $(APP)-modified-annots.annot

clean:
	rm -fr $(APP).elf $(APP).s $(APP).annot $(APP).bbt $(APP).text $(APP)-whitout-annots.elf $(APP)-complete-annots.elf $(APP)-complete-annots.elf $(APP)-modified-annots.elf $(APP)-modified-annots.text $(APP)-modified-annots.bbt $(APP)-modified-annots.annot $(APP).llvmdebug $(APP)
